C   12/02/93 301311312  MEMBER NAME  FORCE    (DWBA93.S)    FVS                 
C**********************************************************************C        
C                                                                      C        
C  CREATION OF DWBA-91(1) INPUT FROM THE DENSITY AND ENERGY DEPENDENT  C        
C  EFFECTIVE INTERACTION (2). THE G-MATRICES ARE BASED ON THE R-SPACE  C        
C                  PARIS NUCLEON-NUCLEON POTENTIAL (3).                C        
C                                                                      C        
C                                                                      C        
C  USED INPUT FILES FOR THIS PROGRAM:                                  C        
C                                                                      C        
C    ------------------------------------------------------------      C        
C     DDNAME            DSNAME                                         C        
C    ------------------------------------------------------------      C        
C     FT04F001          DDTMX.PARIS82                                  C        
C     FT05F001          INPUT                                          C        
C     FT07F001          OUTPUT OF RESULTS WITH  CONTROL CARDS          C        
C    ------------------------------------------------------------      C        
C                                                                      C        
C  INPUT : (FREE FORMAT, MAY BE  USE INTERACTIVELY IN FOREGROUND)      C        
C                                                                      C        
C    ELAB,XM,XV,XR,XA (ELAB: 100,125,150,175,200,250,300,350,400 MEV,  C        
C                         DENSITY FUNCTION PARAMETERS)                 C        
C                                                                      C        
C  OUTPUT: (GOES BETWEEN ILECT=2 AND ILECT=3 CARDS IN DWBA91-INPUT)    C        
C                                                                      C        
C  REFERENCE:                                                          C        
C                                                                      C        
C  (1) J. RAYNAL, DWBA-91, CEA-SACLAY (1991)                           C        
C  (2) H.V. VON GERAMB, 'MICROSCOPIC OPTICAL POTENTIALS', PAGE 44, IN: C        
C      THE INTERACTION BETWEEN MEDIUM ENERGY NUCLEONS IN NUCLEI-1982,  C        
C      EDITED BY:  H.O. MEYER, AIP CONFERENCE PROCEDDINGS NR. 77,      C        
C                AMERICAN INSTITUTE OF PHYSICS (1983)                  C        
C  (3) M. LACOMBE ET AL., PHYS.REV. C21 (1980) 861                     C        
C                                                                      C        
C**********************************************************************C        
                                                                                
      IMPLICIT REAL*8(A-H,O-Z)                                                  
      INTEGER ELAB,TLAB,OUTUNIT                                                 
                                                                                
               PARAMETER (NRANGE=4,NFERM=6,NENG=9)                              
                                                                                
      REAL*8  RANGE(3,NRANGE),FERMI(NFERM)                                      
      REAL*8  VCRE00(NRANGE,NFERM),VCIM00(NRANGE,NFERM)                         
      REAL*8  VCRE01(NRANGE,NFERM),VCIM01(NRANGE,NFERM)                         
      REAL*8  VCRE10(NRANGE,NFERM),VCIM10(NRANGE,NFERM)                         
      REAL*8  VCRE11(NRANGE,NFERM),VCIM11(NRANGE,NFERM)                         
      REAL*8  VLRE10(NRANGE,NFERM),VLIM10(NRANGE,NFERM)                         
      REAL*8  VLRE11(NRANGE,NFERM),VLIM11(NRANGE,NFERM)                         
      REAL*8  VTRE10(NRANGE,NFERM),VTIM10(NRANGE,NFERM)                         
      REAL*8  VTRE11(NRANGE,NFERM),VTIM11(NRANGE,NFERM)                         
      DATA INPUNIT/4/,OUTUNIT/7/,ITERMINAL/5/                                   
                                                                                
C  PARAMETER FOR THE DENSITY FUNCTION REQUIRED IN DWBA91-INPUT                  
C                 (DEFAULT VALID FOR 12-CARBON)                                 
                                                                                
C     DATA XM/12.0/,XV/0.98/,XR/1.09/,XA/0.55/    !    DENSITY FUNCTION         
      DATA XM/12.0/,XV/0.98/,XR/1.09/,XA/0.55/                                  
                                                                                
C=> ENERGY,DENSITY (ALLOWED ELAB: 100,125,150,175,200,250,300,350,400)          
                                                                                
      READ(ITERMINAL,*) ELAB,XM,XV,XR,XA                                        
C                                                                               
C                                                                               
C                                                                               
C                                                                               
      CALL SKIP(INPUNIT,8)                                                      
                                                                                
C=> READ DATA FROM INPUT-UNIT INPUNIT                                           
                                                                                
      DO 1 I=1,NENG                                                             
      READ(INPUNIT,'(T24,I3)') TLAB                                             
      IF (TLAB.NE.ELAB) THEN                                                    
         IF(I.LT.NENG) CALL SKIP(INPUNIT,359)                                   
         GOTO 1                                                                 
      ELSE                                                                      
         DO 6 IFERM=1,NFERM                                                     
         READ(INPUNIT,'(T44,F4.2)') FERMI(IFERM)                                
         CALL SKIP(INPUNIT,12)                                                  
         DO 2 IRANGE=1,NRANGE                                                   
         READ(INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')                        
     +    RANGE(1,IRANGE),VCRE00(IRANGE,IFERM),VCIM00(IRANGE,IFERM)             
     +                   ,VCRE01(IRANGE,IFERM),VCIM01(IRANGE,IFERM)             
2        CONTINUE                                                               
         CALL SKIP(INPUNIT,8)                                                   
         DO 3 IRANGE=1,NRANGE                                                   
         READ(INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')                        
     +    RANGE(1,IRANGE),VCRE10(IRANGE,IFERM),VCIM10(IRANGE,IFERM)             
     +                   ,VCRE11(IRANGE,IFERM),VCIM11(IRANGE,IFERM)             
3        CONTINUE                                                               
         CALL SKIP(INPUNIT,8)                                                   
         DO 4 IRANGE=1,NRANGE                                                   
         READ(INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')                        
     +    RANGE(2,IRANGE),VLRE10(IRANGE,IFERM),VLIM10(IRANGE,IFERM)             
     +                   ,VLRE11(IRANGE,IFERM),VLIM11(IRANGE,IFERM)             
4        CONTINUE                                                               
         CALL SKIP(INPUNIT,8)                                                   
         DO 5 IRANGE=1,NRANGE                                                   
         READ(INPUNIT,'(T2,F4.2,TR1,2E16.8,TR1,2E16.8)')                        
     +    RANGE(3,IRANGE),VTRE10(IRANGE,IFERM),VTIM10(IRANGE,IFERM)             
     +                   ,VTRE11(IRANGE,IFERM),VTIM11(IRANGE,IFERM)             
5        CONTINUE                                                               
         IF (IFERM.NE.6) CALL SKIP(INPUNIT,7)                                   
6     CONTINUE                                                                  
      GOTO 7                                                                    
      ENDIF                                                                     
1     CONTINUE                                                                  
      STOP 'LAB-ENERGY NOT IN LIST, PLEASE TRY AGAIN'                           
                                                                                
C=> WRITE DWBA-INPUT-FILE ON FORTRAN-UNIT OUTUNIT                               
                                                                                
7     CALL DWBAINP(VCRE00,VCIM00,VCRE01,VCIM01,VCRE10,VCIM10,                   
     +     VCRE11,VCIM11,VLRE10,VLIM10,VLRE11,VLIM11,VTRE10,VTIM10,             
     +     VTRE11,VTIM11,RANGE,FERMI,OUTUNIT,XV,XR,XM,XA)                       
      STOP                                                                      
      END                                                                       
      SUBROUTINE SKIP(IUNIT,INT)                                                
      DO 1 I=1,INT                                                              
      READ(IUNIT,*)                                                             
1     CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
C                                                                               
      SUBROUTINE DWBAINP(VCRE00,VCIM00,VCRE01,VCIM01,VCRE10,VCIM10,             
     +     VCRE11,VCIM11,VLRE10,VLIM10,VLRE11,VLIM11,VTRE10,VTIM10,             
     +     VTRE11,VTIM11,RANGE,FERMI,OUTUNIT,XV,XR,XM,XA)                       
C********************************************************************           
C                                                                               
C                  INPUT FOR RAYNAL'S DWBA91-PROGRAM                            
C                                                                               
C********************************************************************           
      IMPLICIT REAL*8(A-H,O-Z)                                                  
      PARAMETER (NRANGE=4,NFERM=6,NENG=9)                                       
      INTEGER ELAB,TLAB,OUTUNIT                                                 
      REAL*8  RANGE(3,NRANGE),FERMI(NFERM)                                      
      REAL*8  VCRE00(NRANGE,NFERM),VCIM00(NRANGE,NFERM)                         
      REAL*8  VCRE01(NRANGE,NFERM),VCIM01(NRANGE,NFERM)                         
      REAL*8  VCRE10(NRANGE,NFERM),VCIM10(NRANGE,NFERM)                         
      REAL*8  VCRE11(NRANGE,NFERM),VCIM11(NRANGE,NFERM)                         
      REAL*8  VLRE10(NRANGE,NFERM),VLIM10(NRANGE,NFERM)                         
      REAL*8  VLRE11(NRANGE,NFERM),VLIM11(NRANGE,NFERM)                         
      REAL*8  VTRE10(NRANGE,NFERM),VTIM10(NRANGE,NFERM)                         
      REAL*8  VTRE11(NRANGE,NFERM),VTIM11(NRANGE,NFERM)                         
      LOGICAL LO16,LOO1,LOO2,LO25,LOO3                                          
      LOGICAL CENTRAL,L2,LS,LS2,TENSOR,Q12                                      
      DIMENSION KTV(14,18),XMU(18)                                              
      DATA LO16,LOO1,LOO2,LO25,LOO3/4*.FALSE.,.TRUE./,HB2ONM/41.48D0/           
      DATA CENTRAL,L2,LS,LS2,TENSOR,Q12/.TRUE.,.FALSE.,.TRUE.,.FALSE.,          
     +  .TRUE.,.FALSE./                                                         
C     EXTERNAL INDEX                                                            
      IF(Q12) LO25=.TRUE.                                                       
      NRANGES=0                                                                 
C                                                                               
      DO 1 I=1,NRANGE                                                           
      DO 10 J=1,MAX(NRANGES,1)                                                  
      IF(XMU(J).EQ.RANGE(1,I)) GOTO 11                                          
10    CONTINUE                                                                  
      NRANGES=NRANGES+1                                                         
      XMU(NRANGES)=RANGE(1,I)                                                   
      J=NRANGES                                                                 
11    IF(CENTRAL) THEN                                                          
      KTV(1,J)=J                                                                
      KTV(2,J)=J                                                                
      KTV(3,J)=J                                                                
      KTV(4,J)=J                                                                
      ENDIF                                                                     
1     CONTINUE                                                                  
      DO 2 I=1,NRANGE                                                           
      DO 20 J=1,MAX(NRANGES,1)                                                  
      IF(XMU(J).EQ.RANGE(2,I)) GOTO 21                                          
20    CONTINUE                                                                  
      NRANGES=NRANGES+1                                                         
      XMU(NRANGES)=RANGE(2,I)                                                   
      J=NRANGES                                                                 
21    IF(L2.AND..NOT.Q12) THEN                                                  
      KTV(11,J)=J                                                               
      KTV(12,J)=J                                                               
      KTV(13,J)=J                                                               
      KTV(14,J)=J                                                               
      ENDIF                                                                     
      IF(L2.AND.Q12) THEN                                                       
      KTV(11,J)=J                                                               
      KTV(12,J)=J                                                               
      ENDIF                                                                     
      IF(LS) THEN                                                               
      KTV(5,J)=J                                                                
      KTV(6,J)=J                                                                
      ENDIF                                                                     
      IF(LS2.OR.(L2.AND.Q12)) THEN                                              
      KTV(9,J)=J                                                                
      KTV(10,J)=J                                                               
      ENDIF                                                                     
2     CONTINUE                                                                  
      DO 3 I=1,NRANGE                                                           
      DO 30 J=1,MAX(NRANGES,1)                                                  
      IF(XMU(J).EQ.RANGE(3,I)) GOTO 31                                          
30    CONTINUE                                                                  
      NRANGES=NRANGES+1                                                         
      XMU(NRANGES)=RANGE(3,I)                                                   
      J=NRANGES                                                                 
31    IF(TENSOR) THEN                                                           
      KTV(7,J)=J                                                                
      KTV(8,J)=J                                                                
      ENDIF                                                                     
3     CONTINUE                                                                  
      WRITE(OUTUNIT,'(3I5)') NRANGES,0,64                                       
      WRITE(OUTUNIT,101) LO16,LOO1,LOO2,LO25,LOO3                               
101   FORMAT(T1,6L1)                                                            
      DO 4 J=1,NRANGES                                                          
      WRITE(OUTUNIT,102) 1.0D0/XMU(J)                                           
102   FORMAT(T1,F10.5)                                                          
      WRITE(OUTUNIT,103) (5*KTV(I,J)/J,I=1,14)                                  
103   FORMAT(T1,14I5)                                                           
4     CONTINUE                                                                  
C                                                                               
      DO 5 I=1,14                                                               
      DO 6 J=1,NRANGES                                                          
      IF(KTV(I,J).NE.0) THEN                                                    
      WRITE(OUTUNIT,104) I,J                                                    
      WRITE(OUTUNIT,'(6F10.5)') 1.0,0.0,XV,XR,XM,XA                             
104   FORMAT(T1,2I5,'    5','    0','    6')                                    
      IF(I.EQ.1) THEN                                                           
      DO 501 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VCRE00(J,K),VCIM00(J,K)                       
 501  CONTINUE                                                                  
 105  FORMAT(T1,F10.4,2F20.8)                                                   
      ENDIF                                                                     
      IF(I.EQ.2) THEN                                                           
      DO 502 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VCRE01(J,K),VCIM01(J,K)                       
 502  CONTINUE                                                                  
      ENDIF                                                                     
      IF(I.EQ.3) THEN                                                           
      DO 503 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VCRE10(J,K),VCIM10(J,K)                       
 503  CONTINUE                                                                  
      ENDIF                                                                     
      IF(I.EQ.4) THEN                                                           
      DO 504 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VCRE11(J,K),VCIM11(J,K)                       
 504  CONTINUE                                                                  
      ENDIF                                                                     
      IF(I.EQ.5) THEN                                                           
      DO 505 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VLRE10(J-4,K),VLIM10(J-4,K)                   
 505  CONTINUE                                                                  
      ENDIF                                                                     
      IF(I.EQ.6) THEN                                                           
      DO 506 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VLRE11(J-4,K),VLIM11(J-4,K)                   
 506  CONTINUE                                                                  
      ENDIF                                                                     
      IF(I.EQ.7) THEN                                                           
      DO 507 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VTRE10(J-4,K),VTIM10(J-4,K)                   
 507  CONTINUE                                                                  
      ENDIF                                                                     
      IF(I.EQ.8) THEN                                                           
      DO 508 K=NFERM,1,-1                                                       
      WRITE(OUTUNIT,105) FERMI(K)**3/(FERMI(NFERM)**3),                         
     &                            VTRE11(J-4,K),VTIM11(J-4,K)                   
 508  CONTINUE                                                                  
      ENDIF                                                                     
      ENDIF                                                                     
6     CONTINUE                                                                  
5     CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       
                                                                                
                                                                                
